/////////////////////////////////////////////////////////////////
//Copyright (C) 2005 NTT CORPORATION.
//
//	WBT個別ログ　進捗状況一覧(グループ単位)
//
//		変更履歴
//			2005.01.31  新規作成  OGA
//
//	機能
//
//	この画面は進捗状況一覧画面(グループ単位)を表示します
//
/////////////////////////////////////////////////////////////////
//------------------------------------------------
//入力値
//	strLoID_o		STRING			LoID
//	strUserID_o		STRING			ユーザーID
//	strLoType_o		STRING			Loタイプ
//	strUID_o		STRING			UID
//------------------------------------------------
//

/*
 * 作成日: 2005/02/19
 *
 * TODO この生成されたファイルのテンプレートを変更するには次へジャンプ:
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
package jp.co.ntt.lms.xmf.actions.lo.wbt.IndividualLog;

import jp.co.ntt.lms.xmf.actions.lo.wbt.IndividualLog.inc.*;
import jp.co.ntt.lms.lo.WBT.IndividualLog.*;
import jp.co.ntt.lms.Common.RDF.*;
import jp.co.ntt.lms.xmo.Assignments.AssignmentsClient;
import jp.co.ntt.lms.xmo.util.*;
import jp.co.ntt.lms.xmo.Lo.LoClient;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import java.util.Vector;
import java.io.UnsupportedEncodingException;
import java.lang.String;
import java.lang.Float;
import java.text.DecimalFormat;
import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;
/**
 * @author Administrator
 *
 * TODO この生成された型コメントのテンプレートを変更するには次へジャンプ:
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
public class GroupProgressStatusAction extends Action{
	
	private IndividualLogMessga_inc IndividualLogMessga_inc = new IndividualLogMessga_inc();
	private IndividualLogCommon_inc IndividualLogCommon_inc = new IndividualLogCommon_inc();
	private IndividualStub_inc IndividualStub_inc = new IndividualStub_inc();
	private IndividualLogComFunc_inc IndividualLogComFunc_inc = new IndividualLogComFunc_inc();

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		///////////////////////////////////////////
		// パラメータ取得
		// 	・LoID		LoID		// 必須
		// 	・userId	ユーザーID	// 必須
		// 	・LoType	Loタイプ	// 必須
		// 	・UID		UID			// 必須
		///////////////////////////////////////////
		String strLoID_o         = request.getParameter( IndividualLogCommon_inc.STR_LOID_o );          // LoID
		String strUserID_o       = request.getParameter( IndividualLogCommon_inc.STR_USERID_o );        // ユーザーID
		String strLoType_o       = request.getParameter( IndividualLogCommon_inc.STR_LOTYPE_o );        // Loタイプ
		String strUID_o          = request.getParameter( IndividualLogCommon_inc.STR_UID_o );           // UID

		// RealLOID取得
		///////////////////////////////////////////

		///////////////////////////////////////////
		// パラメータチェック
		///////////////////////////////////////////
		
		// LoIDの入力チェック
		if( strLoID_o == null || strLoID_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072001);
			request.setAttribute("detail", IndividualLogMessga_inc.D072001);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		// ユーザーIDの入力チェック
		if( strUserID_o == null || strUserID_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072002);
			request.setAttribute("detail", IndividualLogMessga_inc.D072002);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		// Loタイプの入力チェック
		if( strLoType_o == null || strLoType_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072003);
			request.setAttribute("detail", IndividualLogMessga_inc.D072003);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		// UIDの入力チェック
		if( strUID_o == null || strUID_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072004);
			request.setAttribute("detail", IndividualLogMessga_inc.D072004);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		///////////////////////////////////////////
		// RDFNodeの取得
		// ・strUID_o	UID			必須
		///////////////////////////////////////////
		RDFNode objNode = (RDFNode)IndividualStub_inc.getTargetRDFNode( strUID_o , strLoID_o , request.getSession() );
		if( objNode == null ){
			request.setAttribute("message", IndividualLogCommon_inc.MSG_MAKE_STOREDATA_o);
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		////////////////////////
		// 激励メール送信者
		////////////////////////

		////////////////////////
		// データの取得
		////////////////////////
		IndividualLogGroupProgressStatusStoreData objStoreData = new IndividualLogGroupProgressStatusStoreData( strLoID_o, strUserID_o, strLoType_o , objNode);
		if( objStoreData.makeStoreData() != true ){
			request.setAttribute("message", IndividualLogCommon_inc.MSG_MAKE_STOREDATA_o);
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		boolean bActionFlag = false;	// 処理実行フラグ
		// データがない場合
		if( objStoreData.getMaxData() == 0 ){
			request.setAttribute("message", IndividualLogCommon_inc.MSG_DATA_ZERO_o);
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		bActionFlag = true;
		String strTeacherID               = (String)request.getSession().getAttribute("userId");					// 激励メール送信者
		String gstrLearner                = (String)request.getSession().getAttribute("learner");				// 学習者パラメータ

		String strLoginUserID_o      = (String)request.getSession().getAttribute("userId");		// ログインユーザID
		String strTargetID_o         = strUserID_o; 						// ターゲットID

		if(strLoginUserID_o.equals("PE000000")){
			strTargetID_o = null;
		}


		// フラグを追加
		boolean bMailFlag = false;		// メール使用可否フラグ
		boolean bMailDisp = false;		// メール表示フラグ

		// メール機能使用可否チェック
		MailUsable objMailUsable = new MailUsable();
		bMailFlag = objMailUsable.isUsable(strLoginUserID_o, strTargetID_o);
		bMailDisp = ( bMailFlag == true && gstrLearner.equals( "YES" ) != true );
		DecimalFormat objFormat = new DecimalFormat( IndividualLogCommon_inc.DEF_SCORE_FORMAT );

		// アサイン情報生成
		AssignmentsClient asclient = new AssignmentsClient();
		asclient.getAssignInfo( null, strUserID_o, strLoID_o, 0, "off" );

		// 平均表示フォーマット
		DecimalFormat objAverageFormat = new DecimalFormat( IndividualLogCommon_inc.DEF_AVERAGE_FORMAT );
		// 得点表示フォーマット
		DecimalFormat objScoreFormat = new DecimalFormat( IndividualLogCommon_inc.DEF_SCORE_FORMAT );

		request.setAttribute("bMailDisp",new Boolean(bMailDisp));
		request.setAttribute("objStoreData",objStoreData);
		request.setAttribute("asclient",asclient);
		request.setAttribute("strLoID_o",strLoID_o);
		request.setAttribute("IndividualLogComFunc_inc",IndividualLogComFunc_inc);
		request.setAttribute("objAverageFormat",objAverageFormat);
		request.setAttribute("objScoreFormat",objScoreFormat);
		request.setAttribute("gstrLearner",gstrLearner);
				
		
		return mapping.findForward("success");
	}

}
